# +----------------------------------------------------------------------------+
# | License Agreement                                                          |
# |                                                                            |
# | Copyright (c) 1991-2009 Altera Corporation, San Jose, California, USA.     |
# | All rights reserved.                                                       |
# |                                                                            |
# | Any megafunction design, and related net list (encrypted or decrypted),    |
# |  support information, device programming or simulation file, and any other |
# |  associated documentation or information provided by Altera or a partner   |
# |  under Altera's Megafunction Partnership Program may be used only to       |
# |  program PLD devices (but not masked PLD devices) from Altera.  Any other  |
# |  use of such megafunction design, net list, support information, device    |
# |  programming or simulation file, or any other related documentation or     |
# |  information is prohibited for any other purpose, including, but not       |
# |  limited to modification, reverse engineering, de-compiling, or use with   |
# |  any other silicon devices, unless such use is explicitly licensed under   |
# |  a separate agreement with Altera or a megafunction partner.  Title to     |
# |  the intellectual property, including patents, copyrights, trademarks,     |
# |  trade secrets, or maskworks, embodied in any such megafunction design,    |
# |  net list, support information, device programming or simulation file, or  |
# |  any other related documentation or information provided by Altera or a    |
# |  megafunction partner, remains with Altera, the megafunction partner, or   |
# |  their respective licensors.  No other licenses, including any licenses    |
# |  needed under any third party's intellectual property, are provided herein.|
# |  Copying or modifying any file, or portion thereof, to which this notice   |
# |  is attached violates this copyright.                                      |
# |                                                                            |
# | THIS FILE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR    |
# | IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,   |
# | FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    |
# | THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER |
# | LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING    |
# | FROM, OUT OF OR IN CONNECTION WITH THIS FILE OR THE USE OR OTHER DEALINGS  |
# | IN THIS FILE.                                                              |
# |                                                                            |
# | This agreement shall be governed in all respects by the laws of the State  |
# |  of California and by the laws of the United States of America.            |
# |                                                                            |
# +----------------------------------------------------------------------------+

# TCL File Generated by Altera University Program
# DO NOT MODIFY

# +-----------------------------------
# | module altera_up_avalon_de_boards
# | 
set_module_property DESCRIPTION "Creates required PLLs for DE Board Peripherals"
set_module_property NAME altera_up_avalon_de_boards
set_module_property VERSION 9.0
set_module_property GROUP "University Program"
set_module_property AUTHOR "Altera University Program"
set_module_property DISPLAY_NAME "External Clocks for DE Board Periherals"
set_module_property DATASHEET_URL "ftp.altera.com/up/archive/QII_9.0/Altera_Material/University_Program_IP/External_Clocks.pdf"
#set_module_property TOP_LEVEL_HDL_FILE Altera_UP_Avalon_External_Clocks.v
#set_module_property TOP_LEVEL_HDL_MODULE Altera_UP_Avalon_External_Clocks
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE false
set_module_property SIMULATION_MODEL_IN_VERILOG false
set_module_property SIMULATION_MODEL_IN_VHDL false
set_module_property SIMULATION_MODEL_HAS_TULIPS false
set_module_property SIMULATION_MODEL_IS_OBFUSCATED false
set_module_property VALIDATION_CALLBACK validate
set_module_property ELABORATION_CALLBACK elaborate
set_module_property GENERATION_CALLBACK generate
# | 
# +-----------------------------------

# +-----------------------------------
# | files
# | 
#add_file Altera_UP_Avalon_DE_Boards.v {SYNTHESIS SIMULATION}
# | 
# +-----------------------------------

# +-----------------------------------
# | parameters
# | 
add_parameter board string DE2
set_parameter_property board DISPLAY_NAME "DE Board"
set_parameter_property board GROUP "Configurations"
set_parameter_property board UNITS None
set_parameter_property board AFFECTS_PORT_WIDTHS true
set_parameter_property board ALLOWED_RANGES {DE1 DE2 "DE2-70" DE3}
set_parameter_property board VISIBLE true
set_parameter_property board ENABLED true

add_parameter sdram_clk boolean false
set_parameter_property sdram_clk DISPLAY_NAME "SDRAM"
set_parameter_property sdram_clk GROUP "Required Clocks"
set_parameter_property sdram_clk UNITS None
set_parameter_property sdram_clk AFFECTS_PORT_WIDTHS true
set_parameter_property sdram_clk VISIBLE true
set_parameter_property sdram_clk ENABLED true

add_parameter audio_clk boolean false
set_parameter_property audio_clk DISPLAY_NAME "Audio"
set_parameter_property audio_clk GROUP "Required Clocks"
set_parameter_property audio_clk UNITS None
set_parameter_property audio_clk AFFECTS_PORT_WIDTHS true
set_parameter_property audio_clk VISIBLE true
set_parameter_property audio_clk ENABLED true

add_parameter vga_clk boolean false
set_parameter_property vga_clk DISPLAY_NAME "VGA"
set_parameter_property vga_clk GROUP "Required Clocks"
set_parameter_property vga_clk UNITS None
set_parameter_property vga_clk AFFECTS_PORT_WIDTHS true
set_parameter_property vga_clk VISIBLE true
set_parameter_property vga_clk ENABLED true

add_parameter audio_clk_freq string "12.288"
set_parameter_property audio_clk_freq DISPLAY_NAME "Clock Frequency"
set_parameter_property audio_clk_freq GROUP "Audio Clock Settings"
set_parameter_property audio_clk_freq UNITS Megahertz
set_parameter_property audio_clk_freq AFFECTS_PORT_WIDTHS true
set_parameter_property audio_clk_freq ALLOWED_RANGES {"18.432" "16.9344" "12.288" "11.2896" "12.0"}
set_parameter_property audio_clk_freq VISIBLE true
set_parameter_property audio_clk_freq ENABLED false
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point avalon_external_clocks_slave
# | 
add_interface avalon_external_clocks_slave avalon end
set_interface_property avalon_external_clocks_slave holdTime 0
set_interface_property avalon_external_clocks_slave linewrapBursts false
set_interface_property avalon_external_clocks_slave minimumUninterruptedRunLength 1
set_interface_property avalon_external_clocks_slave bridgesToMaster ""
set_interface_property avalon_external_clocks_slave isMemoryDevice false
set_interface_property avalon_external_clocks_slave burstOnBurstBoundariesOnly false
set_interface_property avalon_external_clocks_slave addressSpan 4
set_interface_property avalon_external_clocks_slave timingUnits Cycles
set_interface_property avalon_external_clocks_slave setupTime 0
set_interface_property avalon_external_clocks_slave writeWaitTime 0
set_interface_property avalon_external_clocks_slave isNonVolatileStorage false
set_interface_property avalon_external_clocks_slave addressAlignment DYNAMIC
set_interface_property avalon_external_clocks_slave readWaitStates 0
set_interface_property avalon_external_clocks_slave maximumPendingReadTransactions 0
set_interface_property avalon_external_clocks_slave readWaitTime 0
set_interface_property avalon_external_clocks_slave readLatency 0
set_interface_property avalon_external_clocks_slave printableDevice false

set_interface_property avalon_external_clocks_slave ASSOCIATED_CLOCK clock_reset

add_interface_port avalon_external_clocks_slave byteenable byteenable Input 4
add_interface_port avalon_external_clocks_slave chipselect chipselect Input 1
add_interface_port avalon_external_clocks_slave read read Input 1
add_interface_port avalon_external_clocks_slave write write Input 1
add_interface_port avalon_external_clocks_slave writedata writedata Input 32
add_interface_port avalon_external_clocks_slave readdata readdata Output 32
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point clock_reset
# | 
add_interface clock_reset clock end
set_interface_property clock_reset ptfSchematicName ""

add_interface_port clock_reset reset reset Input 1
add_interface_port clock_reset clk clk Input 1
# | 
# +-----------------------------------

# +-----------------------------------
# | connection point external_interface
# | 
add_interface external_interface conduit end

set_interface_property external_interface ASSOCIATED_CLOCK clock_reset

add_interface_port external_interface ext_clk_50 export Input 1
add_interface_port external_interface ext_clk_27 export Input 1
add_interface_port external_interface system_clk export Output 1
# | 
# +-----------------------------------


# +-----------------------------------
# | Validation function
# | 
proc validate {} {
	set board [ get_parameter_value "board" ]
	set sdram_clk [ get_parameter_value "sdram_clk" ]
	set audio_clk [ get_parameter_value "audio_clk" ]
	set vga_clk [ get_parameter_value "vga_clk" ]
	set audio_clk_freq [ get_parameter_value "audio_clk_freq" ]
	
	set_parameter_property sdram_clk ENABLED false
	set_parameter_property audio_clk ENABLED false
	set_parameter_property vga_clk ENABLED false
	set_parameter_property audio_clk_freq ENABLED false

	if { $board == "DE3" } {
	} else {
		set_parameter_property sdram_clk ENABLED true
		set_parameter_property audio_clk ENABLED true
		set_parameter_property vga_clk ENABLED true

		if { $audio_clk } {
			set_parameter_property audio_clk_freq ENABLED true
		}
	}
}
# | 
# +-----------------------------------

# +-----------------------------------
# | Elaboration function
# | 
proc elaborate {} {
	set board [ get_parameter_value "board" ]
	set sdram_clk [ get_parameter_value "sdram_clk" ]
	set audio_clk [ get_parameter_value "audio_clk" ]
	set vga_clk [ get_parameter_value "vga_clk" ]
	set audio_clk_freq [ get_parameter_value "audio_clk_freq" ]

	if { $board == "DE3" } {
	} else {
		if { $sdram_clk } {
			add_interface_port external_interface DRAM_CLK export Output 1
		}
		if { $audio_clk } {
			add_interface_port external_interface AUD_XCK export Output 1
		}
		if { $vga_clk } {
			add_interface_port external_interface VGA_CLK export Output 1
		}
	}
}
# | 
# +-----------------------------------

# +-----------------------------------
# | Generation function
# | 
proc generate {} {
	send_message info "Starting Generation of External Clocks for DE Boards"

	# get generation settings
	set language [ format "lang=%s" [ get_generation_setting HDL_LANGUAGE ] ]
	set outdir [ format "dir=%s" [ get_generation_setting OUTPUT_DIRECTORY ] ]
	set outname [ format "name=%s" [ get_generation_setting OUTPUT_NAME ] ]

	# get parameter values
	set board [ get_parameter_value "board" ]
	set sdram_clk [ get_parameter_value "sdram_clk" ]
	set audio_clk [ get_parameter_value "audio_clk" ]
	set vga_clk [ get_parameter_value "vga_clk" ]
	set audio_clk_freq [ get_parameter_value "audio_clk_freq" ]

	if { $audio_clk_freq == "18.432" } {
		set aud_clk_mult "AUD_CLK_MULT:15"
		set aud_clk_div  "AUD_CLK_DIV:22"
	} elseif { $audio_clk_freq == "16.9344" } {
		set aud_clk_mult "AUD_CLK_MULT:5"
		set aud_clk_div  "AUD_CLK_DIV:8"
	} elseif { $audio_clk_freq == "12.288" } {
		set aud_clk_mult "AUD_CLK_MULT:14"
		set aud_clk_div  "AUD_CLK_DIV:31"
	} elseif { $audio_clk_freq == "11.2896" } {
		set aud_clk_mult "AUD_CLK_MULT:13"
		set aud_clk_div  "AUD_CLK_DIV:31"
	} else {
		set aud_clk_mult "AUD_CLK_MULT:4"
		set aud_clk_div  "AUD_CLK_DIV:9"
	}

	# set section value
	set use_sdram_clk	[ format "USE_SDRAM_CLK:%d" [ string match "true" $sdram_clk ] ]
	set use_aud_clk		[ format "USE_AUDIO_CLK:%d" [ string match "true" $audio_clk ] ]
	set use_vga_clk		[ format "USE_VGA_CLK:%d" [ string match "true" $vga_clk ] ]

	if { $sdram_clk || $audio_clk || $vga_clk } {
		set using_clocks "USING_CLOCKS:1"
	} else {
		set using_clocks "USING_CLOCKS:0"
	}

	# set top_level_ports and external_port
	set top_level_name [ format "top_level_name=%s" [ get_project_property QUARTUS_PROJECT_NAME ] ]
	set top_level_ports "top_level_ports="
	set module_ports "module_ports="
	foreach port [ get_interface_ports external_interface ] {
		set direction [ get_port_property $port DIRECTION ]
		set width [ get_port_property $port WIDTH ]
		if { $port == "ext_clk_50" } {
			set module_ports  "$module_ports$port:$direction:$width:CLOCK_50;"
		} elseif { $port == "ext_clk_27" } {
			set module_ports  "$module_ports$port:$direction:$width:CLOCK_27;"
		} elseif { $port == "system_clk" } {
			set module_ports  "$module_ports$port:$direction:$width:$port;"
		} elseif { $port == "video_in_clk" } {
			set module_ports  "$module_ports$port:$direction:$width:$port;"
		} else {
			set top_level_ports "$top_level_ports$port:$direction:$width;"
			set module_ports  "$module_ports$port:$direction:$width:$port;"
		}
	}
	
	# set arguments
	set files "files=Altera_UP_Avalon_External_Clocks.v"
	set params "$aud_clk_mult;$aud_clk_div"
	set sections "USE_SLAVE_PORT:1;$use_sdram_clk;$use_aud_clk;$use_vga_clk;$using_clocks" 

	# get generation settings
#	set dest_language	[ get_generation_setting HDL_LANGUAGE ]
	set dest_dir 		[ get_generation_setting OUTPUT_DIRECTORY ]
	set dest_name		[ get_generation_setting OUTPUT_NAME ]
	add_file "$dest_dir$dest_name.v" {SYNTHESIS SIMULATION}

	# Generate HDL
	source "UP_IP_Generator.tcl"
	up_generate "$dest_dir$dest_name.v" "hdl/Altera_UP_Avalon_External_Clocks.v" $dest_name $params $sections
}
# | 
# +-----------------------------------

